## This function is part of Align2, by Jean-Luc Ohl
 
 
 
 
 
 

cd D:\documents\audio\align2\files\octave\;
irmicfileL = 'D:\documents\audio\align2\measurements\testAD1\testAD1-irc-L.wav';
irmicfileR = 'D:\documents\audio\align2\measurements\testAD1\testAD1-irc-R.wav';
irmicfilenameL = "testAD1-irc-L.wav";
irmicfilenameR = "testAD1-irc-R.wav";






















































































mic = load('D:\documents\audio\align2\files\mic\kt-vert1.txt');
irdrcfileL = 'D:\documents\audio\align2\measurements\testAD1\testAD1-ircd-L.wav';
irdrcfilenameL = "testAD1-ircd-L.wav";
irdrcfileR = 'D:\documents\audio\align2\measurements\testAD1\testAD1-ircd-R.wav';
irdrcfilenameR = "testAD1-ircd-R.wav";
convlinphfileL = 'D:\documents\audio\align2\measurements\testAD1\convolution\testAD1-SDLC-L.wav';
convlinphfilenameL = "testAD1-ADMC-L";
convlinphfileR = 'D:\documents\audio\align2\measurements\testAD1\convolution\testAD1-SDLC-R.wav';
convlinphfilenameR = "testAD1-ADMC-R";

target = 'D:\documents\audio\align2\files\target\48.0KHz\bk-3-48.0.txt';
drc = "normal-48.0.drc";
WEL = 350;
WEH = 1;
UW = 3;
UPW = 144;
correction = 80;
psychoacoustic = "none";
Fmin = 10;
Fmax = 20000;
fdevice = '-S1200,220';
fdevice = '-S1200,220';








##############################################################################	
	fext = ".png";
	margins.left   = 0.04;
	margins.right  = 0.01;
	margins.top    = 0.04;
	margins.bottom = 0.11; 
	set(0,"defaultaxesfontsize",9)
	
	# Set the default line width
	DLW = 1.5;
	
	# Colormap, line colors and line width for 3d surface plots
	EDLw = 0.25;
	EDCMap = hsv2rgb([linspace(0.60,0.00,256)', 1.0 * ones(256,1), 0.65 * ones(256,1)]);	
	ULColor = [0.85, 0.85, 0.85];
	LLColor = [0.85, 0.85, 0.85];	
	
	# Enable contour display when set to > 0
	surcntenable = 0;
	mapcntenable = 0;


##############################################################################	
	# Report the stage
	disp("Analysis...");
	fflush(stdout);	

	[irmicL,fs,bps] = wavread([irmicfileL]);
	[irmicR,fs,bps] = wavread([irmicfileR]);	
	[irdrcL,fs,bps] = wavread([irdrcfileL]);
	[irdrcR,fs,bps] = wavread([irdrcfileR]);	
	[convlinphL,fs,bps] = wavread([convlinphfileL]);
	[convlinphR,fs,bps] = wavread([convlinphfileR]);

	irmicL = [zeros(1,480) irmicL(:)' zeros(1,32768)];
	irmicR = [zeros(1,480) irmicR(:)' zeros(1,32768)];
	irdrcL = [zeros(1,480) irdrcL(:)' zeros(1,32768)];
	irdrcR = [zeros(1,480) irdrcR(:)' zeros(1,32768)];	
	convlinphL = [zeros(1,480) convlinphL(:)' zeros(1,32768)];
	convlinphR = [zeros(1,480) convlinphR(:)' zeros(1,32768)];		

	
	[irmicLn,irmicLc] = max(abs(irmicL));		
	[irmicRn,irmicRc] = max(abs(irmicR));	
	[irdrcLn,irdrcLc] = max(abs(irdrcL));		
	[irdrcRn,irdrcRc] = max(abs(irdrcR));	
	[convlinphLn,convlinphLc] = max(abs(convlinphL));		
	[convlinphRn,convlinphRc] = max(abs(convlinphR));	
	
	irmicL = irmicL(irmicLc-480:irmicLc+32287)/irmicLn;
	irmicR = irmicR(irmicRc-480:irmicRc+32287)/irmicRn;		
	irdrcL = irdrcL(irdrcLc-480:irdrcLc+32287)/irdrcLn;	
	irdrcR = irdrcR(irdrcRc-480:irdrcRc+32287)/irdrcRn;	
	convlinphL = convlinphL([(convlinphLc-480):(convlinphLc+32287)]);	
	convlinphR = convlinphR([(convlinphRc-480):(convlinphRc+32287)]);	

	irmicLf = 20 * log10(ssev(irmicL,fs,0.1,1));
	irmicRf = 20 * log10(ssev(irmicR,fs,0.1,1));
	irdrcLf = 20 * log10(ssev(irdrcL,fs,0.1,1));
	irdrcRf = 20 * log10(ssev(irdrcR,fs,0.1,1));	
	convlinphLf = 20 * log10(ssev(convlinphL,fs,0.1,1));
	convlinphRf = 20 * log10(ssev(convlinphR,fs,0.1,1));	
	
##############################################################################
	
	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");
	
mic=[0,-0.01;20,0;100,0;10000,0;24000,-0.01];
	subplot(1,2,1);
	hold("on");

	# Plot 1
	subplot(1,2,1);
	ixg= [1:columns(irmicLf)];
	semilogx(ixg*fs/(2000*columns(irmicLf)), irmicLf, ["2;" irmicfilenameL ";"],"LineWidth",DLW);
	ixg= [1:columns(convlinphLf)];
	semilogx(ixg*fs/(2000*columns(convlinphLf)), convlinphLf, ["1;" convlinphfilenameL ";"],"LineWidth",DLW);
	ixg= [1:columns(irdrcLf)];
	semilogx(ixg*fs/(2000*columns(irdrcLf)), irdrcLf, ["3;" irdrcfilenameL ";"],"LineWidth",DLW);
	
	grid("on");
	axis([0.02, 20, -18, 30]);
	safetics("x",[0.02,0.03,0.05,0.07,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);
	safetics("y",-18:3:30);
	title("DRC-FIR correction");

	# Disable holding the plot and set graph parameters
	subplot(1,2,1);
	hold("off");
	
	# Enable holding the plot
	subplot(1,2,2);
	hold("on");
	
	# Plot 2
	subplot(1,2,2);
	ixg= [1:columns(irmicRf)];
	semilogx(ixg*fs/(2000*columns(irmicRf)),irmicRf,["2;" irmicfilenameR ";"],"LineWidth",DLW);
	ixg= [1:columns(convlinphRf)];
	semilogx(ixg*fs/(2000*columns(convlinphRf)),convlinphRf,["1;" convlinphfilenameR ";"],"LineWidth",DLW);
	ixg= [1:columns(irdrcRf)];
	semilogx(ixg*fs/(2000*columns(irdrcRf)),irdrcRf,["3;" irdrcfilenameR ";"],"LineWidth",DLW);
	
	grid("on");
	axis([0.02, 20, -18, 30]);
	safetics("x",[0.02,0.03,0.05,0.07,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);
	safetics("y",-18:3:30);
	title([drc," HFW:",num2str(UW)," MFexp:",num2str(WEH)," LFW:",num2str(WEL)," correction:",num2str(correction),"% F:",num2str(Fmin),"-",num2str(Fmax)," psychoacoustic:",psychoacoustic]);

	# Disable holding the plot and set graph parameters
	subplot(1,2,2);
	hold("off");	
		
	# Print to the output file
	print([irmicfileL fext],fdevice);

	# Report the stage
	disp("Completed, wait for GNUPlot to complete before opening output files.");
	fflush(stdout);
	
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 