## Copyright (C) 2013 JLO
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
##(at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA




cd D:\documents\audio\align2\files\octave\;
fs =48000;
fprefix = "testabcd";
fpath = 'D:\documents\audio\align2\measurements\testabcd\';
fdevice = '-S1200,220';
limits = 4;
HFW = 3;
LFW = 300;
WEG = 1;
smoothtype = -2;
SE = 10;
mic = load('D:\documents\audio\align2\files\mic\kt-vert1.txt');
wav1nr = 4;
wav2nr = 3;
ir1name = "L1.wav";
ir2name = "R2.wav";
ir2name = "R2.wav";
ir3name = "R1.wav";



wav11 = fft(reshape(wavread('C:\Users\jlo\Desktop\igdef\L1.wav'),1, rows(wavread('C:\Users\jlo\Desktop\igdef\L1.wav'))));
wav12 = fft(reshape(wavread('C:\Users\jlo\Desktop\igdef\L2.wav'),1, rows(wavread('C:\Users\jlo\Desktop\igdef\L2.wav'))));
wav13 = fft(reshape(wavread('C:\Users\jlo\Desktop\igdef\L3.wav'),1, rows(wavread('C:\Users\jlo\Desktop\igdef\L3.wav'))));
wav14 = fft(reshape(wavread('C:\Users\jlo\Desktop\igdef\L4.wav'),1, rows(wavread('C:\Users\jlo\Desktop\igdef\L4.wav'))));
wav1m =+wav11+wav12+wav13+wav14;
 
wav21 = fft(reshape(wavread('C:\Users\jlo\Desktop\igdef\R2.wav'),1, rows(wavread('C:\Users\jlo\Desktop\igdef\R2.wav'))));
wav22 = fft(reshape(wavread('C:\Users\jlo\Desktop\igdef\R3.wav'),1, rows(wavread('C:\Users\jlo\Desktop\igdef\R3.wav'))));
wav23 = fft(reshape(wavread('C:\Users\jlo\Desktop\igdef\R4.wav'),1, rows(wavread('C:\Users\jlo\Desktop\igdef\R4.wav'))));
wav2m =+wav21+wav22+wav23;
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 






##############################################################################
	fext = ".png";
	margins.left   = 0.04;
	margins.right  = 0.01;
	margins.top    = 0.04;
	margins.bottom = 0.11; 
	set(0,"defaultaxesfontsize",9)
	
	# Set the default line width
	DLW = 1.5;
	
	# Colormap, line colors and line width for 3d surface plots
	EDLw = 0.25;
	EDCMap = hsv2rgb([linspace(0.60,0.00,256)', 1.0 * ones(256,1), 0.65 * ones(256,1)]);	
	ULColor = [0.85, 0.85, 0.85];
	LLColor = [0.85, 0.85, 0.85];	
	
	# Enable contour display	when set to > 0
	surcntenable = 0;
	mapcntenable = 0;
	
##############################################################################	
	wav1m = wav1m/wav1nr;
	wav1mi = ifft(wav1m);
	wav1mi = reshape(wav1mi,columns(wav1mi),1);
	[irm1,ic1] = max(abs(wav1mi));		
	wav1mi = wav1mi([(ic1 - 480):(ic1 + (65536 - (480 + 1)))]);
	wav1mi = fftshift(wav1mi);	
	
	#wavwrite(wav1mi,fs,16,[fpath fprefix "wav1m.wav"]);
	#wav1mread = wavread([fpath fprefix "wav1m.wav"]);	
	#wav1mir = ssev(wav1mread,fs,0.17,1);	
		
	wav2m = wav2m/wav2nr;
	wav2mi = ifft(wav2m);
	wav2mi = reshape(wav2mi,columns(wav2mi),1);
	[irm2,ic2] = max(abs(wav2mi));
	wav2mi = wav2mi([(ic2 - 480):(ic2 + (65536 - (480 + 1)))]);
	wav2mi = fftshift(wav2mi);	
	
	#wavwrite(wav2mi,fs,16,[fpath fprefix "wav2m.wav"]);
	#wav2mread = wavread([fpath fprefix "wav2m.wav"]);	
	#wav2mir = ssev(wav2mread,fs,0.17,1);		
##############################################################################

	# Report the stage
	disp("Mic correction...");
	fflush(stdout);	

	disp(mic)
	xp = mic(:,1);
	yp = -mic(:,2);
	ixg = [1:fs/2];
	mic_interp = interp1(xp, yp, ixg, "pchip");
	mic_interp = reshape(mic_interp,columns(mic_interp),1);
	mic_log = exp(mic_interp*log(10)/20);
	mic_log1 = [mic_log(:); zeros(fs/2,1)];		
	mic_ir = ifft(mic_log1);
	mic_ir = fftshift(mic_ir);
	#wavwrite(mic_ir,fs,32,[fpath fprefix "mic_ir.wav"]);	
	#mic_wav = wavread([fpath fprefix "mic_ir.wav"]);	
	
	disp("IR-mic convolution");

	irconv1 = fftconv(wav1mi,mic_ir);
	irconv1b = [zeros(1,480) irconv1(:)' zeros(1,65536)];	
	conv1 = reshape(irconv1b,columns(irconv1b),1);
	[irm1,ic1] = max(abs(conv1));	
	conv1_ = fftshift(conv1);	
	wav1mir = ssev(conv1,fs,0.17,1);
	
	irconv2 = fftconv(wav2mi,mic_ir);
	irconv2b = [zeros(1,480) irconv2(:)' zeros(1,65536)];	
	conv2 = reshape(irconv2b,columns(irconv2b),1);
	[irm2,ic2] = max(abs(conv2));	
	conv2_ = fftshift(conv2);	
	wav2mir = ssev(conv2,fs,0.17,1);

##############################################################################	
	
	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");
	
	# Enable holding the plot
	subplot(1,2,1);
	hold("on");

	# Plot 1
	subplot(1,2,1);
	ixg= [1:columns(wav1mir)];
	semilogx(ixg*fs/(2000*columns(wav1mir)),20*log10(wav1mir),["3;" "" ";"],"LineWidth",DLW);
	
	grid("on");
	axis([0.02, 20, -15, 21]);
	safetics("x",[0.02,0.03,0.05,0.07,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);
	safetics("y",-15:3:21);
	title(["Average 1/6 octave " ir1name ]);
	
	# Disable holding the plot
	subplot(1,2,1);
	hold("off");
	
	# Enable holding the plot
	subplot(1,2,2);
	hold("on");
	
	# Plot 2
	subplot(1,2,2);
	ixg= [1:columns(wav2mir)];
	semilogx(ixg*fs/(2000*columns(wav2mir)),20*log10(wav2mir),["3;" "" ";"],"LineWidth",DLW);
	
	grid("on");
	axis([0.02, 20, -15, 21]);
	safetics("x",[0.02,0.03,0.05,0.07,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);
	safetics("y",-15:3:21);
	title(ir2name);
	
	# Disable holding the plot
	subplot(1,2,2);
	hold("off");	
		
	# Print to the output file
	print([fpath fprefix"-Multiple-1-6octave" fext],fdevice);
	
##############################################################################
	# Report the stage
	disp("Various gating times...");
	fflush(stdout);

	[irm1,ic1] = max(abs(conv1));
	[irm2,ic2] = max(abs(conv2));
	
	# Windows array, in ms
	wlst = [100 30 10 3 1];
	
	# Graph resolution
	gres = 16384;
	
	# Graph pregap
	gpgp = 480;
	
	# Scaling base (dB)
	scbs = 14;
	
	# Scaling delta (dB)
	scdt = -6;
	
	# Compute the index limits
	ixl = floor(2 * 20 * gres / fs);
	ixu = ceil(2 * 20000 * gres / fs);
		
	# Open a new plot	
	newplot();
	clf();
	figure(1,"visible","off");	
	
	# Enable holding the plot
	subplot(1,2,1);
	hold("on");
	subplot(1,2,2);
	hold("on");
	
	# Cycle on the windows sizes
	cscl = scbs;
	cg = 1;
	for cws = wlst
		# Computes the number of samples for the current window
		wns = round(fs * cws / (2 * 1000));
		
		# Creates the response prewindow
		wind = [ones(1,gpgp) ones(1,wns) (blackman(2 * wns)((wns + 1):(2 * wns)))' zeros(1,gres - (gpgp + 2 * wns))]';
		
		# Extract the windowed impulse responses
		wav1miw = conv1([(ic1 - gpgp):(ic1 + (gres - (gpgp + 1)))]) .* wind;
		wav2miw = conv2([(ic1 - gpgp):(ic1 + (gres - (gpgp + 1)))]) .* wind;
					
		# Computes the smoothed magnitude response
		wav1miws = ssev(wav1miw,fs,0.17,1);
		wav2miws = ssev(wav2miw,fs,0.17,1);		
		
		# Computes the graph lower bounds
		glb = fs / (0.7 * wns);
		glb = round(glb / (fs / (1 * gres)));
		glb = max(glb,2);
		
		# Plot the magnitude response
		subplot(1,2,1);
		ixg= [glb:columns(wav1miws)];
		semilogx(1*ixg*fs/(2000*gres), cscl + 20 * log10(wav1miws(ixg)),"color",hsv2rgb([2/3, 1, 0.5 + 0.5 * cg / length(wlst)]),"LineWidth",DLW);
		
		subplot(1,2,2);
		ixg= [glb:columns(wav2miws)];		
		semilogx(1*ixg*fs/(2000*gres), cscl + 20 * log10(wav2miws(ixg)),"color",hsv2rgb([2/3, 1, 0.5 + 0.5 * cg / length(wlst)]),"LineWidth",DLW);
		
		# Adjust the scaling
		cscl = cscl + scdt;
		cg = cg + 1;
	endfor	
	
	subplot(1,2,1);
	hold("off");
	safetics("x",[0.02,0.03,0.05,0.07,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);
	xlabel("Frequency (kHz)");
	grid("on");
	legend(3);
	title(["Average frequency response, 1-3-10-30-100 ms gatings  " ir1name ]);

	subplot(1,2,2);
	hold("off");
	safetics("x",[0.02,0.03,0.05,0.07,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);
	xlabel("Frequency (kHz)");
	grid("on");
	legend(3);
	title(ir2name);
	
	# Save the axis range
	subplot(1,2,1);
	axis([0.02, 20]);	
	g1ax = axis();
	subplot(1,2,2);
	axis([0.02, 20]);	
	g2ax = axis();

	# Computes the uniform axis range
	gax = g1ax;
	gax(3) = -20;
	gax(4) = 40;
		
	# Set the uniform axis range
	subplot(1,2,1);	
	axis(gax);
	safetics("y",gax(3):6:gax(4));
	subplot(1,2,2);	
	axis(gax);
	safetics("y",gax(3):6:gax(4));
	
	# Print to the output file
	print([fpath fprefix "-Multiple-various-gatings" fext ],fdevice);

	# Remove variables no longer used
	clear wind ir1w ir1m ir2w ir2m ixl ixu ixg g1ax g2ax gax;

##############################################################################		
# Report the stage
	disp("Mean psychoacoustic response...");
	fflush(stdout);
	
	# Extract the windowed impulse responses
	ir1w = conv1(ic1-32767:ic1+32768);
	ir2w = conv2(ic2-32767:ic2+32768);

	# Performs the frequency dependant windowing, w1 is for psycho, w2 is for FDW 6 periods
	ir1w1 = irslprefilt(ir1w,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*3*HFW/2000),WEG,4096,1.0,10,0);
	ir1w2 = irslprefilt(ir1w,32758,2 * 20/fs,floor(fs*6/20),2 * 20000/fs,floor(fs*6/20000),1,4096,1.0,10,0);
	ir2w1 = irslprefilt(ir2w,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*3*HFW/2000),WEG,4096,1.0,10,0);
	ir2w2 = irslprefilt(ir2w,32758,2 * 20/fs,floor(fs*6/20),2 * 20000/fs,floor(fs*6/20000),1,4096,1.0,10,0);
	
	# Pad the windowed impulse response
	ir1w1 = [ zeros(1,65536 - length(ir1w1)) ir1w1(:)' ];
	ir1w2 = [ zeros(1,65536 - length(ir1w2)) ir1w2(:)' ];	
	ir2w1 = [ zeros(1,65536 - length(ir2w1)) ir2w1(:)' ];
	ir2w2 = [ zeros(1,65536 - length(ir2w2)) ir2w2(:)' ];
	
	# Computes the smoothed magnitude response
	ir1m1 = ssev(ir1w1,fs,smoothtype,SE,'prepeak');
	ir1m2 = ssev(ir1w2,fs,0.33,1);	

	ir2m1 = ssev(ir2w1,fs,smoothtype,SE,'prepeak');
	ir2m2 = ssev(ir2w2,fs,0.33,1);	
	
	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");
	
	# Enable holding the plot
	subplot(1,2,1);
	hold("on");
	subplot(1,2,2);
	hold("on");
		
	subplot(1,2,1);
	ixg= [1:columns(ir1m1)];
	semilogx(fs * ixg / (2000*columns(ir1m1)),20 * log10(ir1m1(ixg)),["3;" sprintf(" %.0f-%.0fms, WE %.1f, smooth%.2f, SE%.0f",HFW, LFW, WEG, smoothtype,SE) ";"],"LineWidth",DLW);
	safetics("x",[0.02,0.03,0.05,0.07,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);
	grid("on");
	title(["Average psychoacoustic frequency response " ir1name ]);
	
	subplot(1,2,2);
	ixg= [1:columns(ir2m1)];	
	semilogx(fs * ixg / (2000*columns(ir2m1)),20 * log10(ir2m1(ixg)),["3;" sprintf(" %.0f-%.0fms, WE %.1f, smooth%.2f, SE%.0f",HFW, LFW, WEG, smoothtype,SE) ";"],"LineWidth",DLW);
	safetics("x",[0.02,0.03,0.05,0.07,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);
	xlabel("Frequency (kHz)");
	grid("on");
	title(ir2name);
	
	# Plot the magnitude response
	subplot(1,2,1);
	ixg= [1:columns(ir1m2)];	
	semilogx(fs * ixg / (2000*columns(ir1m2)),20 * log10(ir1m2(ixg)),["1;" "FDW 6 periods" ";"],"LineWidth",DLW);
	subplot(1,2,2);
	ixg= [1:columns(ir2m2)];	
	semilogx(fs * ixg / (2000*columns(ir2m2)),20 * log10(ir2m2(ixg)),["1;" "FDW 6 periods" ";"],"LineWidth",DLW);
				
	# Disable holding the plot and set graph parameters
	subplot(1,2,1);
	hold("off");
	subplot(1,2,2);
	hold("off");
		
	# Save the axis range
	subplot(1,2,1);
	axis([0.02, 20]);	
	g1ax = axis();
	subplot(1,2,2);
	axis([0.02, 20]);	
	g2ax = axis();

	# Computes the uniform axis range
	gax = g1ax;
	gax(3) = -15;
	gax(4) = 21;
		
	# Set the uniform axis range
	subplot(1,2,1);	
	axis(gax);
	safetics("y",gax(3):3:gax(4));
	subplot(1,2,2);	
	axis(gax);
	safetics("y",gax(3):3:gax(4));
	
	# Print to the output file
	print([fpath  fprefix "-Multiple-psychoacoustic" fext ],fdevice);	
	
	
##############################################################################		
	

	# Report the stage
	disp("Completed, wait for GNUPlot to complete before opening output files.");
	fflush(stdout);