## This function is part of Align2, by Jean-Luc Ohl
 
 
 
fs =48000;
fdevice = '-S1200,220';
fpath = 'C:\Users\jlo\Desktop\igdef\';
fprefix = "test";
cd D:\documents\audio\align2\files\octave\;
wavnr = 2;
 
 
 
 
 
wav1 = [zeros(1,32768) (wavread('C:\Users\jlo\Desktop\igdef\R4.wav'))' zeros(1,32768)];
[ic,ir1] = max(abs(wav1))
ir1 = irslprefilt(wav1,ir1-20,20/fs,floor(fs*25/20),20000/fs,floor(fs*25/20000),1,4096,1.0,10,0);
wavf1 = 20*log10(ssev(ir1,fs,0.04,1));
wav1 = 20*log10(ssev(wav1,fs,0.04,1));
wav2 = [zeros(1,32768) (wavread('C:\Users\jlo\Desktop\igdef\R3.wav'))' zeros(1,32768)];
[ic,ir2] = max(abs(wav2))
ir2 = irslprefilt(wav2,ir2-20,20/fs,floor(fs*25/20),20000/fs,floor(fs*25/20000),1,4096,1.0,10,0);
wavf2 = 20*log10(ssev(ir2,fs,0.04,1));
wav2 = 20*log10(ssev(wav2,fs,0.04,1));
wavm =+wav1+wav2;
wavfm =+wavf1+wavf2;
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
##############################################################################	 
	fext = ".png";
	margins.left   = 0.04;
	margins.right  = 0.01;
	margins.top    = 0.04;
	margins.bottom = 0.11; 
	set(0,"defaultaxesfontsize",9)
	
	# Set the default line width
	DLW = 1.5;
	
	# Colormap, line colors and line width for 3d surface plots
	EDLw = 0.25;
	EDCMap = hsv2rgb([linspace(0.60,0.00,256)', 1.0 * ones(256,1), 0.65 * ones(256,1)]);	
	ULColor = [0.85, 0.85, 0.85];
	LLColor = [0.85, 0.85, 0.85];	
	
	# Enable contour display when set to > 0
	surcntenable = 0;
	mapcntenable = 0;
##############################################################################	
	wavm = wavm/wavnr;
	wavmi_log = exp(wavm*log(10)/20);
	wavmi_log1 = [wavmi_log(:); zeros(fs/2,1)];	
	wavmi = ifft(wavmi_log1);
	wavmi = fftshift(wavmi);
	wavmi = resample(wavmi,2,1);
	#wavmi = reshape(wavmi,columns(wavmi),1);
	wavwrite(wavmi,fs,32,[fpath "ira.wav"]);
##############################################################################
	
	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");
	
	# Enable holding the plot
	subplot(1,2,1);
	hold("on");

	# Plot 1
	subplot(1,2,1);
	nr=0;
	while (nr<wavnr)
		nr=nr+1;		
		eval(sprintf('wavn = wav%d;', nr));
		ixg= [1:columns(wavn)];
		semilogx(ixg*fs/(2000*columns(wavn)), wavn,["3;" ";"],"LineWidth",DLW);
	endwhile

	ixg= [1:columns(wavm)];
	semilogx(ixg*fs/(2000*columns(wavm)),wavm,["1;" "average" ";"],"LineWidth",DLW);	

	
	grid("on");
	axis([0.02, 20, -30, 30]);
	safetics("x",[0.02,0.03,0.05,0.07,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);
	safetics("y",-30:10:30);
	title("no window, 1/24oct analysis");

	# Disable holding the plot and set graph parameters
	subplot(1,2,1);
	hold("off");
	
	# Enable holding the plot
	subplot(1,2,2);
	hold("on");
	
	# Plot 2
	subplot(1,2,2);
	nr=0;
	while (nr<wavnr)
		nr=nr+1;	
		eval(sprintf('wavfn = wavf%d;', nr));
		ixg= [1:columns(wavfn)];
		semilogx(ixg*fs/(2000*columns(wavfn)),wavfn,["3;" ";"],"LineWidth",DLW);	
	endwhile	
	
	ixg= [1:columns(wavfm)];
	semilogx(ixg*fs/(2000*columns(wavfm)),wavfm/wavnr,["1;" "average" ";"],"LineWidth",DLW);
	
	grid("on");
	axis([0.02, 20, -30, 30]);
	safetics("x",[0.02,0.03,0.05,0.07,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);
	safetics("y",-30:10:30);
	title("1/24 octave constant-Q window");

	# Disable holding the plot and set graph parameters
	subplot(1,2,2);
	hold("off");	
		
	# Print to the output file
	print([fpath "ira" fext],fdevice);

	# Report the stage
	disp("Completed");
	fflush(stdout);
	