## Copyright (C) 2012 Jean-Luc Ohl
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
##(at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##
## This function is part of Align2


cd D:\documents\audio\align2\files\octave\;
wavfile1 = 'D:\documents\audio\roomEQ\mesures-sur-sites\igor130613\subseul.wav';
wavfilename1 = "subseul.wav";
wavfilepath1 = 'D:\documents\audio\align2\measurements\igor-sub2b\';
wavfile2 = 'D:\documents\audio\roomEQ\mesures-sur-sites\igor130613\subseul2.wav';
wavfilename2 = "subseul2.wav";
mic = load('D:\documents\audio\align2\files\mic\kt-vert1.txt');
fdevice = '-S1200,220';






##############################################################################	
	fext = ".png";
	margins.left   = 0.04;
	margins.right  = 0.01;
	margins.top    = 0.04;
	margins.bottom = 0.11; 
	set(0,"defaultaxesfontsize",9)
	# Set the default line width
	DLW = 1.5;
	# Colormap, line colors and line width for 3d surface plots
	EDLw = 0.25;
	EDCMap = hsv2rgb([linspace(0.60,0.00,256)', 1.0 * ones(256,1), 0.65 * ones(256,1)]);	
	ULColor = [0.85, 0.85, 0.85];
	LLColor = [0.85, 0.85, 0.85];	
	# Enable contour display	when set to > 0
	surcntenable = 0;
	mapcntenable = 0;
	
##############################################################################	
	[wav1,fs,bps] = wavread([wavfile1]);
	[wav2,fs,bps] = wavread([wavfile2]);
	
##############################################################################	

	# Report the stage
	disp("Mic correction...");
	fflush(stdout);	

	disp(mic)
	xp = mic(:,1);
	yp = -mic(:,2);
	ixg = [1:fs/2];
	mic_interp = interp1(xp, yp, ixg, "pchip");
	mic_interp = reshape(mic_interp,columns(mic_interp),1);
	mic_log = exp(mic_interp*log(10)/20);
	mic_log1 = [mic_log(:); zeros(fs/2,1)];		
	mic_ir = ifft(mic_log1);
	mic_ir = fftshift(mic_ir);

##############################################################################	

	wav1 = [zeros(1,480) wav1(:)' zeros(1,65536)];	
	[irm,ic] = max(abs(wav1));	
	wav1 = wav1([(ic - 480):(ic + (65536 - (480 + 1)))]);
	wav1 = wav1/max(abs(wav1(:)));	
	wav1 = fftshift(wav1);

	wav2 = [zeros(1,480) wav2(:)' zeros(1,65536)];	
	[irm,ic] = max(abs(wav2));	
	wav2 = wav2([(ic - 480):(ic + (65536 - (480 + 1)))]);
	wav2 = wav2/max(abs(wav2(:)));	
	wav2 = fftshift(wav2);
		
###################		
	disp("convolution");
	
	irconv1 = fftconv(wav1,mic_ir);
	irconv1 = irconv1/max(abs(irconv1));
	[irm,ic] = max(abs(irconv1));	
	irconv1 = irconv1([(ic - 480):(ic + (16384 - (480 + 1)))]);	
	wavwrite(irconv1,fs,16,[wavfilepath1 "irc-L.wav"]);	

	irconv2 = fftconv(wav2,mic_ir);
	irconv2 = irconv2/max(abs(irconv2));
	[irm,ic] = max(abs(irconv2));	
	irconv2 = irconv2([(ic - 480):(ic + (16384 - (480 + 1)))]);	
	wavwrite(irconv2,fs,16,[wavfilepath1 "irc-R.wav"]);

##############################################################################		
	
	# Report the stage
	disp("Completed.");
	fflush(stdout);