## This function is part of Align2, by Jean-Luc Ohl
 
 
 
fs =48000;
fdevice = '-S1200,220';
fpath = 'C:\Users\jlo\Desktop\igdef\syber\';
fprefix = "test";
cd D:\documents\audio\align2\files\octave\;
wavnr = 6;
 
wav1 = fft(reshape(wavread('C:\Users\jlo\Desktop\igdef\syber\igor-enceinte droite en convolution, rglage 2.wav'),1, rows(wavread('C:\Users\jlo\Desktop\igdef\syber\igor-enceinte droite en convolution, rglage 2.wav'))));
wav2 = fft(reshape(wavread('C:\Users\jlo\Desktop\igdef\syber\igor-enceinte droite en convolution, rglage 3.wav'),1, rows(wavread('C:\Users\jlo\Desktop\igdef\syber\igor-enceinte droite en convolution, rglage 3.wav'))));
wav3 = fft(reshape(wavread('C:\Users\jlo\Desktop\igdef\syber\igor-enceinte droite en convolution, rglage 4.wav'),1, rows(wavread('C:\Users\jlo\Desktop\igdef\syber\igor-enceinte droite en convolution, rglage 4.wav'))));
wav4 = fft(reshape(wavread('C:\Users\jlo\Desktop\igdef\syber\igor-enceinte droite en FIR, rglage 1.wav'),1, rows(wavread('C:\Users\jlo\Desktop\igdef\syber\igor-enceinte droite en FIR, rglage 1.wav'))));
wav5 = fft(reshape(wavread('C:\Users\jlo\Desktop\igdef\syber\igor-enceinte droite sans ttire en convolution, rglage 4.wav'),1, rows(wavread('C:\Users\jlo\Desktop\igdef\syber\igor-enceinte droite sans ttire en convolution, rglage 4.wav'))));
wav6 = fft(reshape(wavread('C:\Users\jlo\Desktop\igdef\syber\igor-enceinte droite sans ttire en FIR, rglage 1.wav'),1, rows(wavread('C:\Users\jlo\Desktop\igdef\syber\igor-enceinte droite sans ttire en FIR, rglage 1.wav'))));
wavm =+wav1+wav2+wav3+wav4+wav5+wav6;
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 








##############################################################################	
	fext = ".png";
	margins.left   = 0.04;
	margins.right  = 0.01;
	margins.top    = 0.04;
	margins.bottom = 0.11; 
	set(0,"defaultaxesfontsize",9)
	
	# Set the default line width
	DLW = 1.5;
	
	# Colormap, line colors and line width for 3d surface plots
	EDLw = 0.25;
	EDCMap = hsv2rgb([linspace(0.60,0.00,256)', 1.0 * ones(256,1), 0.65 * ones(256,1)]);	
	ULColor = [0.85, 0.85, 0.85];
	LLColor = [0.85, 0.85, 0.85];	
	
	# Enable contour display when set to > 0
	surcntenable = 0;
	mapcntenable = 0;

##############################################################################	
	wav1f = ifft(wav1);
	wav1s = ssev(wav1f,fs,0.1,1);
	wav2f = ifft(wav2);
	wav2s = ssev(wav2f,fs,0.1,1);	
	wavm = wavm/wavnr;
	wavmi = ifft(wavm);
	wavmi = reshape(wavmi,columns(wavmi),1);
	wavwrite(wavmi,fs,16,[fpath "wavm.wav"]);
	wavmread = wavread([fpath "wavm.wav"]);	
	wavmir = ssev(wavmread,fs,0.1,1);	
	
	
##############################################################################
	
	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");
	
	# Enable holding the plot
	subplot(1,2,1);
	hold("on");

	# Plot 1
	subplot(1,2,1);
	ixg= [1:columns(wav1s)];
	semilogx(ixg*fs/(1000*columns(wav1s)), 20*log10(wav1s), ["3;" "wav1" ";"],"LineWidth",DLW);
	ixg= [1:columns(wav2s)];
	semilogx(ixg*fs/(1000*columns(wav2s)), 20*log10(wav2s), ["1;" "wav2" ";"],"LineWidth",DLW);

	
	grid("on");
	axis([0.02, 20, -15, 21]);
	safetics("x",[0.02,0.03,0.05,0.07,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);
	safetics("y",-15:3:21);
	title("two responses");

	# Disable holding the plot and set graph parameters
	subplot(1,2,1);
	hold("off");
	
	# Enable holding the plot
	subplot(1,2,2);
	hold("on");
	
	# Plot 2
	subplot(1,2,2);
	ixg= [1:columns(wavmir)];
	semilogx(ixg*fs/(1000*columns(wavmir)),20*log10(wavmir),["3;" "average" ";"],"LineWidth",DLW);

	
	grid("on");
	axis([0.02, 20, -15, 21]);
	safetics("x",[0.02,0.03,0.05,0.07,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);
	safetics("y",-15:3:21);
	title("average response");

	# Disable holding the plot and set graph parameters
	subplot(1,2,2);
	hold("off");	
		
	# Print to the output file
	print([fpath "average-ir" fext],fdevice);

	# Report the stage
	disp("Completed, wait for GNUPlot to complete before opening output files.");
	fflush(stdout);
	