set frequency=48000
set directory2=D:\documents\audio\align2\measurements\testAP6\
set prefix=testAP6
set WEL1=16800
set WEL2=11760
set WEL3=5880
set WEL4=4200
set WEH=1
set BCIW=1
set UPW=144
set taps=12288
set mic=D:\documents\audio\align2\files\mic\kt-vert1.txt
set drc=D:\documents\audio\align2\files\drc\48.0KHz\normal-48.0.drc
set target=D:\documents\audio\align2\files\target\\48.0KHz\flat-48.0.txt
set ir-L=D:\documents\audio\align2\measurements\testAP6\testAP6-APMC-L.wav.pcm
set ir-R=D:\documents\audio\align2\measurements\testAP6\testAP6-APMC-R.wav.pcm
set correction=1
set maxgain=0.01
set Fmin=10
set Fmax=20000
set path=D:\documents\audio\align2\files\
set PTType=N







cd %path%
drc.exe --BCInFile=%ir-L% --MPWindowExponent=%WEH% --EPWindowExponent=%WEH% --RTWindowExponent=%WEH% --MPLowerWindow=%WEL1% --MPUpperWindow=%UPW% --EPUpperWindow=%UPW% --RTUpperWindow=%UPW% --EPLowerWindow=%WEL2% --RTLowerWindow=%WEL1% --ISPELowerWindow=%WEL3% --ISPEUpperWindow=%WEL4% --PLStartFreq=%Fmin% --PLEndFreq=%Fmax% --PSOutWindow=%taps% --PSOutFile=%directory2%convolution\%prefix%-SDLC-L.pcm --PSPointsFile=%target% --MSOutWindow=%taps% --TCOutFile=%directory2%%prefix%-ircd-L.pcm --PTType=%PTType% --PLType=M --PLMaxGain=%maxgain% --PSInterpolationType=H %drc%
drc.exe --BCInFile=%ir-R% --MPWindowExponent=%WEH% --EPWindowExponent=%WEH% --RTWindowExponent=%WEH% --MPLowerWindow=%WEL1% --MPUpperWindow=%UPW% --EPUpperWindow=%UPW% --RTUpperWindow=%UPW% --EPLowerWindow=%WEL2% --RTLowerWindow=%WEL1% --ISPELowerWindow=%WEL3% --ISPEUpperWindow=%WEL4% --PLStartFreq=%Fmin% --PLEndFreq=%Fmax% --PSOutWindow=%taps% --PSOutFile=%directory2%convolution\%prefix%-SDLC-R.pcm --PSPointsFile=%target% --MSOutWindow=%taps% --TCOutFile=%directory2%%prefix%-ircd-R.pcm --PTType=%PTType% --PLType=M --PLMaxGain=%maxgain% --PSInterpolationType=H %drc%

sox.exe -t raw -e float -b 32 -r %frequency% -c 1 %ir-L% -t wav -b 16 -c 1 -s %directory2%%prefix%-ir-L.wav
sox.exe -t raw -e float -b 32 -r %frequency% -c 1 %ir-R% -t wav -b 16 -c 1 -s %directory2%%prefix%-ir-R.wav
sox.exe -t raw -e float -b 32 -r %frequency% -c 1 %ir-L% -t wav -b 16 -c 1 -s %directory2%%prefix%-irc-L1.wav
sox.exe -t raw -e float -b 32 -r %frequency% -c 1 %ir-R% -t wav -b 16 -c 1 -s %directory2%%prefix%-irc-R1.wav
sox.exe -t raw -e float -b 32 -r %frequency% -c 1 %directory2%%prefix%-ircd-L.pcm -t wav -b 16 -c 1 -s %directory2%%prefix%-ircd-L1.wav
sox.exe -t raw -e float -b 32 -r %frequency% -c 1 %directory2%%prefix%-ircd-R.pcm -t wav -b 16 -c 1 -s %directory2%%prefix%-ircd-R1.wav
sox.exe -t raw -e float -b 32 -r %frequency% -c 1 %directory2%convolution\%prefix%-SDLC-L.pcm -t wav -b 16 -c 1 -s %directory2%convolution\%prefix%-SDLC--L1.wav
sox.exe -t raw -e float -b 32 -r %frequency% -c 1 %directory2%convolution\%prefix%-SDLC-R.pcm -t wav -b 16 -c 1 -s %directory2%convolution\%prefix%-SDLC--R1.wav
sox.exe -t raw -e float -b 32 -r %frequency% -c 1 %directory2%convolution\%prefix%-SDMC-L.pcm -t wav -b 16 -c 1 -s %directory2%convolution\%prefix%-SDMC--L1.wav
sox.exe -t raw -e float -b 32 -r %frequency% -c 1 %directory2%convolution\%prefix%-SDMC-R.pcm -t wav -b 16 -c 1 -s %directory2%convolution\%prefix%-SDMC--R1.wav

ping -n 2 127.0.0.1 >nul
sox.exe --norm %directory2%%prefix%-irc-L1.wav %directory2%%prefix%-irc-L.wav
sox.exe --norm %directory2%%prefix%-irc-R1.wav %directory2%%prefix%-irc-R.wav
sox.exe --norm %directory2%%prefix%-ircd-L1.wav %directory2%%prefix%-ircd-L.wav
sox.exe --norm %directory2%%prefix%-ircd-R1.wav %directory2%%prefix%-ircd-R.wav
sox.exe --norm %directory2%convolution\%prefix%-SDLC--L1.wav %directory2%convolution\%prefix%-SDLC-L.wav 
sox.exe --norm %directory2%convolution\%prefix%-SDLC--R1.wav %directory2%convolution\%prefix%-SDLC-R.wav
sox.exe --norm %directory2%convolution\%prefix%-SDMC--L1.wav %directory2%convolution\%prefix%-SDMC-L.wav 
sox.exe --norm %directory2%convolution\%prefix%-SDMC--R1.wav %directory2%convolution\%prefix%-SDMC-R.wav

sox.exe %directory2%convolution\%prefix%-SDLC-L.wav %directory2%convolution\%prefix%-SDLC-L1.wav trim 1500s 6144s
sox.exe %directory2%convolution\%prefix%-SDLC-R.wav %directory2%convolution\%prefix%-SDLC-R1.wav trim 1500s 6144s
sox.exe %directory2%convolution\%prefix%-SDMC-L.wav %directory2%convolution\%prefix%-SDMC-L1.wav trim 1000s 6144s
sox.exe %directory2%convolution\%prefix%-SDMC-R.wav %directory2%convolution\%prefix%-SDMC-R1.wav trim 1000s 6144s

sox.exe -t wav %directory2%convolution\%prefix%-SDLC-L1.wav -t f32 %directory2%opendrc\%prefix%-SDLO-L.bin
sox.exe -t wav %directory2%convolution\%prefix%-SDLC-R1.wav -t f32 %directory2%opendrc\%prefix%-SDLO-R.bin
sox.exe -t wav %directory2%convolution\%prefix%-SDMC-L1.wav -t f32 %directory2%opendrc\%prefix%-SDMO-L.bin
sox.exe -t wav %directory2%convolution\%prefix%-SDMC-R1.wav -t f32 %directory2%opendrc\%prefix%-SDMO-R.bin


del %directory2%convolution\%prefix%-SDLC--L1.wav
del %directory2%convolution\%prefix%-SDLC--R1.wav
del %directory2%convolution\%prefix%-SDMC--L1.wav
del %directory2%convolution\%prefix%-SDMC--R1.wav
del %directory2%%prefix%-irc-L1.wav
del %directory2%%prefix%-irc-R1.wav
del %directory2%%prefix%-ircd-L1.wav
del %directory2%%prefix%-ircd-R1.wav
del %directory2%*.pcm
del %directory2%convolution\*.pcm